
; ----------- MS-DOS 6.22 boot loader source code -----------
; disassembled and commented by Martin Hinner <martin@tdp.cz>
; -----------------------------------------------------------

data_1e		equ	78h
data_2e		equ	7C0Bh			;*
data_3e		equ	7C0Dh			;*
data_4e		equ	7C0Eh			;*
data_5e		equ	7C10h			;*
data_6e		equ	7C11h			;*
data_7e		equ	7C13h			;*
data_8e		equ	7C15h			;*
data_9e		equ	7C16h			;*
data_10e	equ	7C18h			;*
data_11e	equ	7C1Ah			;*
data_12e	equ	7C1Ch			;*
data_13e	equ	7C1Eh			;*
data_14e	equ	7C20h			;*
data_15e	equ	7C24h			;*
data_16e	equ	7C25h			;*
data_17e	equ	7C3Eh			;*
data_18e	equ	7C49h			;*
data_19e	equ	7C4Bh			;*
data_20e	equ	7C4Dh			;*
data_21e	equ	7C4Fh			;*
data_22e	equ	7C50h			;*
data_23e	equ	7C52h			;*
data_24e	equ	7D9Eh			;*
data_25e	equ	7DE6h			;*

;------------------------------------------------------------  seg_a   ----

seg_a		segment	byte public
		assume cs:seg_a  , ds:seg_a
		org 7c00h

start:		jmp short r_start
		nop
oemid	db 'MSDOS5.0'
	db 00h, 02h, 02h, 01h, 00h, 02h
	db 70h, 00h,0D0h, 02h,0FDh, 02h
	db 00h, 12h, 00h, 02h, 00h
	db 10 dup (0)
extsig	db  29h, 12h, 03h
	db '88'
vlabel	db 'NO NAME    '
fsid	db 'FAT12   '
r_start:
	cli				; Disable interrupts
	xor	ax,ax			; ax=0
	mov	ss,ax			; ss=0
	mov	sp,7C00h		; sp=7c00; ss:sp = 0000:7c00
	push	ss
	pop	es			; es=0
	mov	bx,data_1e
	lds	si,dword ptr ss:[bx]	; Load 32 bit ptr
	push	ds
	push	si
	push	ss
	push	bx
	mov	di,data_17e
	mov	cx,0Bh
	cld				; Clear direction
	rep	movsb			; Rep when cx >0 Mov [si] to es:[di]
	push	es
	pop	ds
	mov	byte ptr [di-2],0Fh
	mov	cx,ds:7c18h		; pocet sektoru/ stopa
	mov	[di-7],cl
	mov	[bx+2],ax
	mov	word ptr [bx],7C3Eh
	sti				; Enable interrupts
	int	13h			; Disk  dl=drive a  ah=func 00h
						;  reset disk, al=return status
	jc	loc_4			; Jump if carry Set
	xor	ax,ax			; Zero register
	cmp	ds:data_7e,ax
	je	loc_3			; Jump if equal
	mov	cx,ds:data_7e
	mov	ds:data_14e,cx
loc_3:
	mov	al,ds:7c10h		; pocet fat tabulek
	mul	word ptr ds:7c16h	; * pocet sektoru v fat
	add	ax,ds:7c1ch		; + spec. hidden secs
	adc	dx,ds:data_13e		; .. hi byte + cf
	add	ax,ds:7c0eh		; res. sektory pred FAT (=1)
	adc	dx,0			; hi_byte +=cf
	mov	ds:data_22e,ax
	mov	ds:data_23e,dx
	mov	ds:data_18e,ax
	mov	ds:data_19e,dx
	mov	ax,20h
	mul	word ptr ds:data_6e	; ax = data * ax
	mov	bx,ds:data_2e
	add	ax,bx
	dec	ax
	div	bx			; ax,dx rem=dx:ax/reg
	add	ds:data_18e,ax
	adc	word ptr ds:data_19e,0
	mov	bx,500h
	mov	dx,ds:data_23e
	mov	ax,ds:data_22e
	call	sub_2
	jc	loc_4			; Jump if carry Set
	mov	al,1
	call	sub_3
	jc	loc_4			; Jump if carry Set
	mov	di,bx
	mov	cx,0Bh			; size of filename
	mov	si,offset file1		; "IO.SYS"
	repe	cmpsb			; strncmp(root[0],IO_SYS,0xb);
	jnz	loc_4			;   ... not same
	lea	di,[bx+20h]		; next filename, should be MSDOS.SYS
	mov	cx,0Bh			; size of filename
	repe	cmpsb			; strncmp(root[1],MSDSOS_SYS,0xb);
	jz	loc_6			;  ... same, ok ==> continue
loc_4:
	mov si,offset errmsg		; display error message
	call puts
	xor	ax,ax
	int	16h			; wait for ANY key
	pop	si
	pop	ds
	pop	word ptr [si]		; restore int
	pop	word ptr [si+2]
	int	19h			; ... and reboot
loc_5:
	pop	ax
	pop	ax
	pop	ax
	jmp	short loc_4
loc_6:
	mov	ax,[bx+1Ah]
	dec	ax
	dec	ax
	mov	bl,ds:data_3e
	xor	bh,bh			; Zero register
	mul	bx			; dx:ax = reg * ax
	add	ax,ds:data_18e
	adc	dx,ds:data_19e

	mov	bx,700h			; dest = 0000:0700 (es:bx)
	mov	cx,3			; how many sectors

readsec:
	push	ax
	push	dx
	push	cx
	call	sub_2			; recalculate logical to phys. sector
	jc	loc_5			; error!
	mov	al,1			; read one sector (al)
	call	sub_3			; read sector
	pop	cx
	pop	dx
	pop	ax
	jc	loc_4			; error reading sector, abend.
	add	ax,1
	adc	dx,0
	add	bx,ds:data_2e
	loop readsec

	mov	ch,ds:data_8e		; media descriptor
	mov	dl,ds:data_15e		; physical (0x80,0x00) drive
	mov	bx,ds:data_18e		; AX:BX = start data sector
	mov	ax,ds:data_19e		; (first datasec of bootdrive)

	;jmp 0070:0000
	db	0EAh
	dw	0, 70h			;  Fixup - byte match

;
;   PUTS - put string to screen
;

puts:
		lodsb			; String [si] to al
		or al,al		; Zero ?
		jz loc_ret_10		; Jump if zero
		mov ah,0Eh
		mov bx,7
		int 10h
		jmp short puts

; External Entry into Subroutine 

sub_2:
		cmp	dx,ds:data_10e
		jae	loc_9			; Jump if above or =
		div	word ptr ds:data_10e	; ax,dxrem=dx:ax/data
		inc	dl
		mov	ds:data_21e,dl
		xor	dx,dx			; Zero register
		div	word ptr ds:data_11e	; ax,dxrem=dx:ax/data
		mov	ds:data_16e,dl
		mov	ds:data_20e,ax
		clc				; Clear carry flag
		retn
loc_9:
		stc				; Set carry flag

loc_ret_10:
		retn


;
;                              SUBROUTINE
;

sub_3		proc	near
		mov	ah,2
		mov	dx,ds:data_20e
		mov	cl,6
		shl	dh,cl			; Shift w/zeros fill
		or	dh,ds:data_21e
		mov	cx,dx
		xchg	ch,cl
		mov	dl,ds:data_15e
		mov	dh,ds:data_16e
		int	13h			; Disk  dl=drive ?  ah=func 02h
						;  read sectors to memory es:bx
						;   al=#,ch=cyl,cl=sectr,dh=head
		retn
sub_3		endp

errmsg	db 13,10
	db 'Non-System disk or disk error', 13,10
	db 'Replace and press any key when ready', 13,10,0

file1	db 'IO      SYS'
file2	db 'MSDOS   SYS'

	org 7dfeh
	db 55h,0AAh

seg_a		ends



		end
